//+------------------------------------------------------------------+
//|                                                     Dogooder.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>

double TenkansenArray[];
double KijunSenArray[];
double SenkouSpanAArray[];
double SenkouSpanBArray[];
double ChikouSpanArray[];
int barsCount = 10;
int tradeNow = 0;
int TakeProfit = 100;
int StopLoss = 100;
double LotSize = 0.01;
int candlesToLapse = 10;
double buyTP = 0;
double buySL = 0;
CTrade trade;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(60);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int IchimokoDefinition = iIchimoku(_Symbol,_Period,9,26,52);

   double   Ask = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK), _Digits);
   double   Bid = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID), _Digits);  

   int fibHigh = iHighest(Symbol(), Period(), MODE_HIGH, barsCount, 0);
   int fibLow  = iLowest(Symbol(), Period(), MODE_LOW, barsCount, 0);  

   string signal = "";

   MqlRates PriceInformation[];   
   ArraySetAsSeries(PriceInformation, true);
   int Data = CopyRates(Symbol(), Period(),0,10,PriceInformation);

   bool timeLapsed = true;

   for (int i = PositionsTotal()-1; i >= 0; i--)
   {
      if (PositionGetSymbol(i)==_Symbol &&
          PositionSelectByTicket(PositionGetTicket(i)))
      {
         if (PositionGetInteger(POSITION_TIME) > iTime(Symbol(),Period(),candlesToLapse))
         {
            timeLapsed = false;
            break;
         }
      }
   }
   
   if (timeLapsed && isNewCandle())
      tradeNow = 1;

   ArraySetAsSeries(TenkansenArray, true);
   ArraySetAsSeries(KijunSenArray, true);
   ArraySetAsSeries(SenkouSpanAArray, true);
   ArraySetAsSeries(SenkouSpanBArray, true);
   ArraySetAsSeries(ChikouSpanArray, true);

   CopyBuffer(IchimokoDefinition,0, 0, 3, TenkansenArray);
   CopyBuffer(IchimokoDefinition,1, 0, 3, KijunSenArray);
   CopyBuffer(IchimokoDefinition,2, 0, 3, SenkouSpanAArray);
   CopyBuffer(IchimokoDefinition,3, 0, 3, SenkouSpanBArray);
   CopyBuffer(IchimokoDefinition,4, 0, 3, ChikouSpanArray);

   double TenkansenValue   = TenkansenArray[1];   
   double KijunSenValue    = KijunSenArray[1];     
   double SenkouSpanAValue = SenkouSpanAArray[1];     
   double SenkouSpanBValue = SenkouSpanBArray[1];  
   double ChikouSpanValue  = ChikouSpanArray[1];        

   if (TenkansenValue < PriceInformation[0].open)
      signal = "buy";

   if (TenkansenValue < PriceInformation[0].open)
      signal = "buy";

   if (TenkansenValue > KijunSenValue && TenkansenValue > SenkouSpanAValue && 
       PriceInformation[0].open > SenkouSpanAValue && SenkouSpanAValue > SenkouSpanBValue && tradeNow == 1)
   {
      buyTP = Ask + (TakeProfit * Point()); 
      buySL = Ask - (StopLoss * Point());
      trade.Buy(LotSize, NULL, Ask, buySL, buyTP, NULL);
      tradeNow = 0;
   }
 }


// Insuring a new candle is created.

bool isNewCandle()

  {

static int BarsOnChart=0;

if(Bars(_Symbol,PERIOD_CURRENT)==BarsOnChart)

return false;

BarsOnChart=Bars(_Symbol,PERIOD_CURRENT);

return true;

  }

//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction& trans,
                        const MqlTradeRequest& request,
                        const MqlTradeResult& result)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
//---
   
  }
//+------------------------------------------------------------------+
